
From: Richard Purdie <rpurdie@rpsys.net>

Ensure ide-taskfile.c calls any driver specific end_request function if
present.

Signed-off-by: Richard Purdie <rpurdie@rpsys.net>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/ide/ide-taskfile.c |    8 +++++++-
 1 files changed, 7 insertions(+), 1 deletion(-)

diff -puN drivers/ide/ide-taskfile.c~ensure-ide-taskfile-calls-any-driver-specific drivers/ide/ide-taskfile.c
--- devel/drivers/ide/ide-taskfile.c~ensure-ide-taskfile-calls-any-driver-specific	2006-02-16 14:16:46.000000000 -0800
+++ devel-akpm/drivers/ide/ide-taskfile.c	2006-02-16 14:16:46.000000000 -0800
@@ -375,7 +375,13 @@ static void task_end_request(ide_drive_t
 		}
 	}
 
-	ide_end_request(drive, 1, rq->hard_nr_sectors);
+	if (rq->rq_disk) {
+		ide_driver_t *drv;
+
+		drv = *(ide_driver_t **)rq->rq_disk->private_data;;
+		drv->end_request(drive, 1, rq->hard_nr_sectors);
+	} else
+		ide_end_request(drive, 1, rq->hard_nr_sectors);
 }
 
 /*
_
